<template>
  <!-- SignUp Form -->
  <form id="_sign-up-form" class="w-full">

    <!-- Error messages -->
    <t-alert v-if="form.globalError" variant="error" class="mb-8" show>
      <p class="text-error">{{ form.globalError }}</p>
    </t-alert>

    <!-- Firstname -->
    <Input
      v-model="firstnameValue"
      name="firstname"
      :variant="firstnameState ? 'primary' : 'error'"
      :label="$h.capitalize($t('user.firstname'))"
      :placeholder="$h.capitalize($t('user.firstname'))"
      :error="getFieldErrorMessage('firstname')"
      required
      fluid
    />

    <!-- Lastname -->
    <Input
      v-model="lastnameValue"
      name="lastname"
      :variant="lastnameState ? 'primary' : 'error'"
      :label="$h.capitalize($t('user.lastname'))"
      :placeholder="$h.capitalize($t('user.lastname'))"
      :error="getFieldErrorMessage('lastname')"
      required
      fluid
    />

    <!-- Email -->
    <Input
      v-model="emailValue"
      name="email"
      :variant="emailState ? 'primary' : 'error'"
      :label="$h.capitalize($t('user.email'))"
      :placeholder="$h.capitalize($t('user.email'))"
      :description="emailDescription"
      :error="emailErrorMessage"
      :validated-status="emailValue.length > 0 ? isEmailValid : null"
      :lazy-validation="checkEmail"
      :wait="1000"
      @changed="isEmailAvailable = false; emailDescription = ''; emailErrorMessage = ''"
      required
      fluid
    />

    <!-- Password -->
    <InputPassword
      v-model="passwordValue"
      name="password"
      :variant="passwordState ? 'primary' : 'error'"
      :placeholder="$h.capitalize($t('user.password'))"
      :label="$h.capitalize($t('user.password'))"
      :description="$t('user.passwordPolicyDescription')"
      :error="getFieldErrorMessage('password')"
      required
      fluid
    />

    <!-- Confirm password -->
    <InputPassword
      v-model="confirmPasswordValue"
      name="confirmPassword"
      :variant="confirmPasswordState ? 'primary' : 'error'"
      :label="$h.capitalize($t('user.confirmPassword'))"
      :placeholder="$h.capitalize($t('user.confirmPassword'))"
      required
      fluid
      class="mb-6"
    />

    <!-- Confirm button -->
    <Button
      variant="primary"
      :disabled="!isFormValid"
      @click.native="handleOk"
      classes="mx-auto"
      fluid
    >
      {{ $t('global.confirm') | capitalize }}
    </Button>

  </form>
</template>

<script>
// vuex helpers
import { mapActions } from 'vuex'
// BaseForm
import BaseForm from '@/components/commons/form/BaseForm'
// utils
import { validateEmail } from '#utils'

/**
 * SignUpForm component
 */
export default {
  name: 'SignUpForm',
  extends: BaseForm,
  data () {
    return {
      emailDescription: '',
      emailErrorMessage: '',
      checkEmailLoading: false,
      isEmailAvailable: false
    }
  },
  // 'form' option (see src/components/commons/form/BaseForm)
  form: {
    fields: {
      /**
       * firstname
       */
      firstname: {
        // Default: generate 'firstnameValue' & 'firstnameChanged'
        default: function () {
          return ''
        },
        // Generate: 'firstnameState'
        state: function () {
          return !this.isFieldInError('firstname')
        },
        // Generate: 'isFirstnameValid'
        isValid: function () {
          return this.firstnameValue.length > 0
        }
      },
      /**
       * lastname
       */
      lastname: {
        // Default: generate 'lastnameValue' & 'lastnameChanged'
        default: function () {
          return ''
        },
        // Generate: 'lastnameState'
        state: function () {
          return !this.isFieldInError('lastname')
        },
        // Generate: 'isLastnameValid'
        isValid: function () {
          return this.lastnameValue.length > 0
        }
      },
      /**
       * email
       */
      email: {
        // Default: generate 'emailValue' & 'emailChanged'
        default: function () {
          return ''
        },
        // Generate: 'emailState'
        state: function () {
          return !this.isFieldInError('email') // No errors ?
            ? this.emailValue.length > 0 // Filled ?
              ? this.isEmailValid // Valid ?
              : true
            : false // else -> errors
        },
        // Generate: 'isEmailValid'
        isValid: function () {
          return this.isEmailAvailable &&
            validateEmail(this.emailValue)
        },
        failed: {
          ruleToErrorCode: {
            // Sort by most important rule error message to display
            'rule:Email': 'e0032',
            'rule:Unique': 'e0031'
          }
        }
      },
      /**
       * password
       */
      password: {
        // Default: generate 'passwordValue' & 'passwordChanged'
        default: function () {
          return ''
        },
        // Generate: 'passwordState'
        state: function () {
          return !this.isFieldInError('password') // No errors ?
            ? this.passwordValue.length > 0 // Filled ?
              ? this.isPasswordValid // Valid ?
              : true
            : false // else -> errors
        },
        // Generate: 'isPasswordValid'
        isValid: function () {
          return this.$root.auth.doesPasswordMatchPolicy(this.passwordValue)
        }
      },
      /**
       * confirmPassword
       */
      confirmPassword: {
        // Default: generate 'confirmPasswordValue' & 'confirmPasswordChanged'
        default: function () {
          return ''
        },
        // Generate: 'confirmPasswordState'
        state: function () {
          return !this.isFieldInError('confirmPassword') // No errors ?
            ? this.confirmPasswordValue.length > 0 // Filled ?
              ? this.isConfirmPasswordValid // Valid ?
              : true
            : false // else -> errors
        },
        // Generate: 'isConfirmPasswordValid'
        isValid: function () {
          return this.$root.auth.doesPasswordMatchPolicy(this.confirmPasswordValue) &&
            this.passwordValue === this.confirmPasswordValue
        }
      }
    }
  },
  methods: {
    // Map actions from 'Users' store module
    ...mapActions('Users', [
      'createUser'
    ]),
    /**
     * Handle click on 'confirm' submit button.
     *
     * @param {Object} evt - The event payload
     * @returns {void}
     */
    async handleOk (evt) {
      // Prevent click
      evt.preventDefault()
      // Reset errors before
      this.resetErrors()
      // Wait for sign up function
      const createUserResponse = await this.createUser({
        data: {
          // required
          firstname: this.firstnameValue,
          lastname: this.lastnameValue,
          email: this.emailValue,
          password: this.passwordValue,
          password_confirmation: this.confirmPasswordValue
        }
      })
      // If passed
      if (!(createUserResponse instanceof Error)) {
        // Go login
        this.$router.push('/login')
      // Else parse server error
      } else {
        this.setFormErrors(createUserResponse) // Set form errors from response
      }
    },
    /**
     * Check if email is available
     */
    async checkEmail () {
      if (validateEmail(this.emailValue)) { // If email format is valid
        this.checkEmailLoading = true
        try {
          // Wait for check request
          await this.$APIManager.use('ServerAPI').request('POST', '/users/check-email', {
            data: {
              email: this.emailValue.trim()
            }
          })
          this.emailDescription = this.$t('views.SignUp.form.emailAvailable')
          this.isEmailAvailable = true
        } catch (error) {
          // 409 -> already taken
          if (error.response.status === 409) {
            this.emailErrorMessage = this.$t('errors.e0031') // "e0031": "Email has already been taken."
          }
          // 429 -> Too many requests
          if (error.response.status === 429) {
            alert('Arrête toi petit robot =)')
          }
        }
        this.checkEmailLoading = false
      }
      return true
    }
  }
}
</script>

<style lang="scss" scoped>
#_sign-up-form {
  //
}
</style>
